VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsWarden"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'-----------------------------------------------------
' MirageBot Warden Class
' Written by RealityRipple
'-----------------------------------------------------

Option Explicit

Private Declare Function StandardSHA Lib "RSHA.dll" (sVal As String) As String
Private Position As Long
Private RandomData() As Byte
Private RandomSource1() As Byte
Private RandomSource2() As Byte

Private Function RShift(ByVal pnValue As Double, ByVal pnShift As Long) As Long
    Dim Shft As String
    Shft = str$(pnValue / (2 ^ pnShift))
    If InStrB(Shft, ".") <> 0 Then
        RShift = CLng(Left$(Shft, InStr(Shft, ".") - 1))
    Else
        RShift = CLng(Shft)
    End If
End Function
Public Sub Initialize(Seed As String)
    Dim Length1 As Long
    Dim Length2 As Long
    Dim Seed1() As Byte
    Dim Seed2() As Byte
    Length1 = RShift(Len(Seed), 1)
    Length2 = Len(Seed) - Length1
    ReDim Seed1(Length1 - 1)
    ReDim Seed2(Length2 - 1)
    StrToByteArray Mid$(Seed, 1, Length1), Seed1
    StrToByteArray Mid$(Seed, Length1 + 1, Length2), Seed2
    ReDim RandomData(&H13) As Byte
    StrToByteArray StandardSHA(ByteArrayToStr(Seed1)), RandomSource1
    StrToByteArray StandardSHA(ByteArrayToStr(Seed2)), RandomSource2
    Update
    Position = 0
End Sub
Private Sub Update()
    StrToByteArray StandardSHA(ByteArrayToStr(RandomSource1) & ByteArrayToStr(RandomData) & ByteArrayToStr(RandomSource2)), RandomData
End Sub
Private Function GetByte() As Byte
    GetByte = RandomData(Position)
    Position = Position + 1
    If Position >= &H14 Then
        Position = 0
        Update
    End If
End Function
Public Function GetBytes(ByVal bytes As Long) As String
    Dim i As Integer
    Dim Buffer() As Byte
    ReDim Buffer(bytes) As Byte
    For i = 0 To bytes
        Buffer(i) = GetByte
    Next i
    GetBytes = ByteArrayToStr(Buffer)
End Function
Public Sub StrToByteArray(ByVal sStr As String, ByRef Ary() As Byte)
    ReDim Ary(Len(sStr) - 1) As Byte
    CopyMemory Ary(0), ByVal sStr, Len(sStr)
End Sub
Public Function ByteArrayToStr(ByRef bByt() As Byte, Optional ByVal lLoc As Long = 0) As String
    Dim sStr As String
    sStr = String$(UBound(bByt) + 1, 0)
    CopyMemory ByVal sStr, bByt(lLoc), UBound(bByt) + 1
    ByteArrayToStr = sStr
End Function
Public Sub SimpleCrypt(ByRef bBase() As Byte, ByRef bKey() As Byte)
    Dim lVal As Long
    Dim i As Long
    Dim lPos As Long
    Dim temp As Byte
    ReDim bKey(&H101) As Byte
    For i = 0 To &HFF
        bKey(i) = i
    Next i
    For i = 1 To &H40
        lVal = lVal + bKey(i * 4 - 4) + bBase(lPos Mod (UBound(bBase) + 1))
        lPos = lPos + 1
        temp = bKey(i * 4 - 4)
        bKey(i * 4 - 4) = bKey(lVal And &HFF)
        bKey(lVal And &HFF) = temp
        lVal = lVal + bKey(i * 4 - 3) + bBase(lPos Mod (UBound(bBase) + 1))
        lPos = lPos + 1
        temp = bKey(i * 4 - 3)
        bKey(i * 4 - 3) = bKey(lVal And &HFF)
        bKey(lVal And &HFF) = temp
        lVal = lVal + bKey(i * 4 - 2) + bBase(lPos Mod (UBound(bBase) + 1))
        lPos = lPos + 1
        temp = bKey(i * 4 - 2)
        bKey(i * 4 - 2) = bKey(lVal And &HFF)
        bKey(lVal And &HFF) = temp
        lVal = lVal + bKey(i * 4 - 1) + bBase(lPos Mod (UBound(bBase) + 1))
        lPos = lPos + 1
        temp = bKey(i * 4 - 1)
        bKey(i * 4 - 1) = bKey(lVal And &HFF)
        bKey(lVal And &HFF) = temp
    Next i
End Sub
Public Sub DoCrypt(ByRef bData() As Byte, ByRef bKey() As Byte, ByRef bRet() As Byte)
    Dim i As Long
    Dim temp As Byte
    Dim y As Long
    Dim Z As Long
    ReDim bRet(UBound(bData))
    CopyMemory bRet(0), bData(0), UBound(bData) + 1
    y = bKey(&H100)
    Z = bKey(&H101)
    For i = 0 To UBound(bData)
        y = (y + 1) And &HFF
        Z = (Z + bKey(y)) And &HFF
        temp = bKey(y)
        bKey(y) = bKey(Z)
        bKey(Z) = temp
        bRet(i) = bRet(i) Xor bKey((CInt(bKey(y)) + CInt(bKey(Z))) And &HFF)
    Next i
    bKey(&H100) = y
    bKey(&H101) = Z
End Sub
